/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.log.Logger
 *  fire.pb.game.SRollCardConfig
 *  fire.pb.main.ConfigManager
 *  fire.pb.npc.ForturneWheelType
 *  fire.pb.util.HighQualityRandom
 *  fire.pb.util.Misc
 *  xbean.Pod
 *  xbean.RollCardInfo
 *  xbean.WheelItem
 */
package fire.pb.fanpai;

import fire.log.Logger;
import fire.pb.fanpai.CardItem;
import fire.pb.game.SRollCardConfig;
import fire.pb.main.ConfigManager;
import fire.pb.npc.ForturneWheelType;
import fire.pb.util.HighQualityRandom;
import fire.pb.util.Misc;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.TreeMap;
import xbean.Pod;
import xbean.RollCardInfo;
import xbean.WheelItem;

public class RollCardManager {
    public static final Logger logger = Logger.getLogger((String)"AWARD");
    private static Random hRandom = new HighQualityRandom();
    private Map<Integer, List<CardItem>> rollCardMap = new HashMap<Integer, List<CardItem>>();

    public static RollCardManager getInstance() {
        return SingletonHolder.singleton;
    }

    private RollCardManager() {
        this.reload();
    }

    public void reload() {
        TreeMap map = ConfigManager.getInstance().getConf(SRollCardConfig.class);
        if (map != null) {
            for (SRollCardConfig config : map.values()) {
                ArrayList<CardItem> cardItems = new ArrayList<CardItem>();
                this.rollCardMap.put(config.getId(), cardItems);
                for (String item : config.getObjs()) {
                    CardItem cardItem = new CardItem();
                    String[] temp = (item = item.replace("；", ";")).split(";");
                    if (temp.length < 6) {
                        logger.info((Object)"Exception:RollCard  配置文件有问题");
                        continue;
                    }
                    int type = Integer.parseInt(temp[0]);
                    int number = Integer.parseInt(temp[1]);
                    int times = Integer.parseInt(temp[3]);
                    int probability = Integer.parseInt(temp[4]);
                    int mustShoot = 0;
                    int itemId = 0;
                    int bind = 0;
                    int msgId = 0;
                    if ((type == 1 || type == 5) && temp.length == 8) {
                        itemId = Integer.parseInt(temp[2]);
                        bind = Integer.parseInt(temp[5]);
                        msgId = Integer.parseInt(temp[6]);
                        mustShoot = Integer.parseInt(temp[7]);
                    } else {
                        mustShoot = Integer.parseInt(temp[5]);
                    }
                    cardItem.setType(type);
                    cardItem.setBind(bind);
                    cardItem.setTimes(times);
                    cardItem.setNumber(number);
                    cardItem.setMsgId(msgId);
                    cardItem.setProbability(probability);
                    cardItem.setItemId(itemId);
                    cardItem.setRealIndex(mustShoot);
                    cardItem.setObs(item);
                    cardItems.add(cardItem);
                }
            }
        }
    }

    public List<CardItem> choseCard(int keyId, int choseNum) {
        List<CardItem> items = this.rollCardMap.get(keyId);
        ArrayList<CardItem> choseItem = new ArrayList<CardItem>();
        if (items == null) {
            return choseItem;
        }
        ArrayList<CardItem> allItem = new ArrayList<CardItem>();
        allItem.addAll(items);
        if (items.size() <= choseNum) {
            choseItem.addAll(items);
        } else {
            int needsize;
            for (CardItem item : allItem) {
                if (item.getRealIndex() != 1) continue;
                choseItem.add(item);
            }
            if (choseItem.size() > choseNum) {
                for (int i = choseItem.size() - 1; i >= choseNum; --i) {
                    choseItem.remove(i);
                }
            }
            if ((needsize = choseNum - choseItem.size()) <= 0) {
                return choseItem;
            }
            allItem.removeAll(choseItem);
            for (int i = 0; i < needsize; ++i) {
                int[] proArray = new int[allItem.size()];
                for (int j = 0; j < allItem.size(); ++j) {
                    proArray[j] = ((CardItem)allItem.get(j)).getProbability();
                }
                int index = Misc.getProbability((int[])proArray, (Random)hRandom);
                if (index == -1) continue;
                CardItem aa = (CardItem)allItem.remove(index);
                choseItem.add(aa);
            }
        }
        return choseItem;
    }

    public int getSelectIndex(List<CardItem> items) {
        int[] proArray = new int[items.size()];
        for (int j = 0; j < items.size(); ++j) {
            proArray[j] = items.get(j).getProbability();
        }
        int index = Misc.getProbability((int[])proArray, (Random)hRandom);
        return index == -1 ? 0 : index;
    }

    public void clearLastCard(RollCardInfo info) {
        info.setBaseexp(0);
        info.setBasemoney(0);
        info.setBasesmoney(0);
        info.setIndex(0);
        info.setServiceid(0);
        info.setTakeflag(0);
        info.getWheelitems().clear();
    }

    public List<WheelItem> toWheelItemList(List<CardItem> items) {
        ArrayList<WheelItem> list = new ArrayList<WheelItem>();
        for (CardItem item : items) {
            WheelItem wheelItem = Pod.newWheelItem();
            wheelItem.setItemid(item.getItemId());
            wheelItem.setBind(item.getBind());
            wheelItem.setItemtype(item.getType());
            wheelItem.setMsgid(item.getMsgId());
            wheelItem.setNum(item.getNumber());
            wheelItem.setTimes(item.getTimes());
            list.add(wheelItem);
        }
        return list;
    }

    public ArrayList<ForturneWheelType> tiForturneWheelType(List<CardItem> items) {
        ArrayList<ForturneWheelType> wheelItems = new ArrayList<ForturneWheelType>();
        for (CardItem item : items) {
            ForturneWheelType wheel = new ForturneWheelType();
            wheel.id = item.getItemId();
            wheel.itemtype = item.getType();
            wheel.num = item.getNumber();
            wheel.times = item.getTimes();
            wheelItems.add(wheel);
        }
        return wheelItems;
    }

    static class SingletonHolder {
        static RollCardManager singleton = new RollCardManager();

        SingletonHolder() {
        }
    }
}

